﻿/*
====== READ THIS ========
This code was created as a part of the seminar on 
flash game programing at the University of Munich (Ludwig-
Maximlians Universität.

The code may be used for educational purposes only. All
rights reserverd by the author.

Author: Max Maurer
E-Mail: max.maurer@ifi.lmu.de
(c) 2011
If you have any questions don't hasitate to contact me.
=========================
*/
package {
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;
	public class BoardFace extends MovieClip {
		private const HOLES_X:int = 7;
		private const HOLES_Y:int = 6;
		private var field:Array;
		private var currentPlayer:int;
		private var stoneCount:int;
		public function BoardFace():void {
		}
		
		public function init():void {
			stage.addEventListener(MouseEvent.CLICK, clickHandler);
			resetBoard();
		}
		
		public function resetBoard() {
			while (container.numChildren>0) container.removeChildAt(0);
			currentPlayer = 0;
			nextPlayer();
			stoneCount = 0;
			field = new Array();
			for (var i:int=0;i<HOLES_Y;i++) {
				field[i]=new Array();
				for (var j:int=0;j<HOLES_X;j++) {
					field[i][j]=0;
				}
			}
		}
		
		public function clickHandler(evt:MouseEvent):void {
			if (mouseX>width) return;
			if (mouseX<0) return;
			var slotX:int = int(mouseX/(width/HOLES_X));
			var slotY:int = getFreeY(slotX);
			if (stoneCount>=HOLES_X*HOLES_Y) {
				resetBoard();
				return ; 
			}
			if (slotY<0) return;
			var c:Coin;
			if (currentPlayer==1) {
				c = new RedCoin();
			} else {
				c = new BlueCoin();
			}
			c.x = c.width*slotX;
			c.y = -c.height;
			container.addChild(c);
			field[slotY][slotX]=currentPlayer;
			c.fallTo(slotY*c.height);
			var winner:int = checkWinner();
			if (winner!=0) {
				dispatchEvent(new MessageEvent(MessageEvent.DISPLAY_MESSAGE, "Player "+winner+" won!"));
				stoneCount=HOLES_X*HOLES_Y;
				return;
			}
			stoneCount++;
			if (stoneCount>=HOLES_X*HOLES_Y) {
				dispatchEvent(new MessageEvent(MessageEvent.DISPLAY_MESSAGE, "No player has won!"));
				return;
			}
			nextPlayer();
		}
		
		private function nextPlayer() {
			currentPlayer++;
			if (currentPlayer>2) currentPlayer=1;
			if (currentPlayer==1) {
				dispatchEvent(new MessageEvent(MessageEvent.DISPLAY_MESSAGE, "Red player is on"));
			} else {
				dispatchEvent(new MessageEvent(MessageEvent.DISPLAY_MESSAGE, "Blue player place your coin"));
			}
		}
		
		private function checkWinner():int {
			for (var fieldY:int=0;fieldY<HOLES_Y;fieldY++) {
				for (var fieldX:int=0;fieldX<HOLES_X;fieldX++) {
					var owner:int = field[fieldY][fieldX];
					if (owner==0) continue;
					var result:int = checkField(fieldY,fieldX,owner);
					if (result!=0) return result;
				}
			}
			return 0;
		}
		
		private function getField(fieldY:int,fieldX:int):int {
			if (fieldY<0) return 0;
			if (fieldX<0) return 0;
			if (fieldY>=field.length) return 0;
			if (fieldX>=field[0].length) return 0;
			return field[fieldY][fieldX];
		}
		
		private function checkField(fieldY:int,fieldX:int,owner:int):int {
			// check all lines going away from here 
			var c:int;
			var val:int;
			var matches:Boolean=true;
			// to the right 
			for (c=1;c<=3;c++) {
				val = getField(fieldY,fieldX+c);
				if (val==0 || val!=owner) matches=false;
			}
			if (matches) return owner;
			matches=true;
			// to the left
			for (c=1;c<=3;c++) {
				val = getField(fieldY,fieldX-c);
				if (val==0 || val!=owner) matches=false;
			}
			if (matches) return owner;
			matches=true;
			// to the top
			for (c=1;c<=3;c++) {
				val = getField(fieldY-c,fieldX);
				if (val==0 || val!=owner) matches=false;
			}
			if (matches) return owner;
			matches=true;
			// to the bottom
			for (c=1;c<=3;c++) {
				val = getField(fieldY+c,fieldX);
				if (val==0 || val!=owner) matches=false;
			}
			if (matches) return owner;
			matches=true;
			// diagonal up right
			for (c=1;c<=3;c++) {
				val = getField(fieldY-c,fieldX+c);
				if (val==0 || val!=owner) matches=false;
			}
			if (matches) return owner;
			matches=true;
			// diagonal up left
			for (c=1;c<=3;c++) {
				val = getField(fieldY-c,fieldX-c);
				if (val==0 || val!=owner) matches=false;
			}
			if (matches) return owner;
			matches=true;
			// diagonal down right
			for (c=1;c<=3;c++) {
				val = getField(fieldY+c,fieldX+c);
				if (val==0 || val!=owner) matches=false;
			}
			if (matches) return owner;
			matches=true;
			// diagonal down left
			for (c=1;c<=3;c++) {
				val = getField(fieldY+c,fieldX-c);
				if (val==0 || val!=owner) matches=false;
			}
			if (matches) return owner;
			return 0;
		}
		
		private function getFreeY(xAxis:int):int {
			var currentY=HOLES_Y-1;
			while (currentY>=0 && field[currentY][xAxis]!=0) currentY--;
			return currentY;
		}
	}
}